package jp.co.gihyo.webdb.vol35.tdd.webapp.rest.impl;

import jp.co.gihyo.webdb.vol35.tdd.webapp.rest.DaoOperation;

import org.seasar.framework.beans.BeanDesc;
import org.seasar.framework.beans.factory.BeanDescFactory;
import org.seasar.framework.container.ComponentDef;
import org.seasar.framework.container.S2Container;

public class DaoOperationImpl implements DaoOperation {

    public Object getById(String daoNamePrefix, long id) {
        String daoName = daoNamePrefix + "Dao";
        ComponentDef cd =
            container.getComponentDef(daoName);
        BeanDesc desc =
            BeanDescFactory.getBeanDesc(cd.getComponentClass());
        Object entity = desc.invoke(
                cd.getComponent(),
                "getById",
                new Object[]{new Long(id)});
        return entity;
    }
    
    private S2Container container;
    public void setContainer(S2Container container) {
        this.container = container;
    }
}
